!=================================================================
!  ɽ̲ٷ׻ץ: Ȼ, Crank-Nicolson ˡ
!
!  2000/09/21  
!  2000/10/31  ; 2D ǥ
!=================================================================

      subroutine CLTSFC
     I   ( FHEAT , FXRADD, FXSOL,
     O     TEMPG , TSFC  ,
     C     SIGMA , ALBEDO, CPGRND, 
     C     CDTURBG,DTIME , DENSG ,
     G     GDZ   , GDZM  , 
     D     NX    , NXB   , NZ   , NZB   ,
     D     NZG   , NZGB                   )

!-----------------------------------------------------------------      
      implicit real*8 ( a-h,o-z )
!-----------------------------------------------------------------      

      dimension FHEAT (-2:NXB,2)
      dimension FXRADD(-2:NXB,-2:NZB)
      dimension TSFC(-2:NXB), FXSOL(-2:NXB)
      dimension TEMPG (-2:NXB,NZG)
      dimension GDZ(0:NZGB), GDZM(0:NZG)

      dimension TEMPW (NZG)

      dimension
     \     ELMG_FOR(NZG,NZG),   ! 1
     \     ELMG_BCK(NZG,NZG)    ! 2

      dimension                 ! LAPACK Ѻ
     \     DGL(NZG-1), 
     \     DG(NZG), 
     \     DGU(NZG-1), 
     \     DGU2(NZG-2),
     \     BG(NZG),
     \     IPIVG(NZG)

!---------------------------------------------------------------------
! 

      call SETMTRXG
     I   ( CDTURBG, 
     O     ELMG_FOR, ELMG_BCK, DGL, DG, DGU,
     G     GDZ , GDZM,
     D     DTIME, NZG, NZGB      )

!---------------------------------------------------------------------
!  A ʬ

      call DGTTRF
     \   ( NZG, DGL, DG, DGU, DGU2, IPIVG, INFO)


      do ix = -2, NXB

         do iz = 1, NZG
            TEMPW(iz) = TEMPG(ix,iz)
         end do
!-----------------------------------------------------------------      
! Ǯեå

         HEAT0 = FXSOL(ix) * ( 1.0D0 - ALBEDO )
     \        - SIGMA * TEMPW(NZG)**4.0D0 
     \        + FXRADD(ix, 0)
     \        - FHEAT(ix,1)

!---------------------------------------------------------------------
! ͤδͿ˷׻
         
         TEMPW(NZG) = TEMPW(NZG) 
     \        + DTIME / DENSG / CPGRND / GDZ(NZG) * HEAT0

!---------------------------------------------------------------------
! Ȼη׻

         call CLDIFG
     V      ( TEMPW, 
     I        ELMG_BCK,
     W        DGL, DG, DGU, DGU2, BG, IPIVG,
     D        NZG )

!---------------------------------------------------------------------

         do iz = 1, NZG
            TEMPG(ix,iz) = TEMPW(iz)
         end do

      end do

      do IX = -2, NXB
         TSFC( IX ) = TEMPG( IX, NZG )
      end do

!---------------------------------------------------------------------

      return

      end

